<?php
/**
 * @file File is used for log creation
 */

/**
 * Create log
 * @param  object $entity   entity object for logging
 * @param  string $log_type [insert,delete,update]
 * @return boolean           logging successfull
 */
function entity_log_create_log($entity,$type,$log_type,$fields = FALSE){
  $logging = variable_get('entity_log_logging_enabled', []);

  $id = '';
  //change id by type
  switch ($type) {
    case 'node':
      $id = $entity->nid;
      break;
    case 'commerce_order':
      $id = $entity->order_id;
      break;
    case 'commerce_product':
      $id = $entity->product_id;
    default:
      if(isset($entity->id)){
        $id = $entity->id;
      }
      break;
  }
  switch ($log_type) {
    case 'insert':
      //check where is logging enabled
      foreach($logging as $log_key =>$log_value){
        switch ($log_key) {
          case 'watchdog':
            if($log_value === $log_key){
              db_set_active(variable_get('entity_log_database_selected','default'));
              watchdog('entity_log', 'Entity: @type, Bundle: @bundle, ID: @id is inserted by user @uid .',
              [
                '@type' => $type,
                '@bundle' => $entity->type,
                '@id' => $id,
                '@uid' => $entity->uid,
              ],
              $severity = WATCHDOG_INFO,
              $link = NULL);
            }
            db_set_active();
            break;
          case 'entity':
            //entity_log_create_entity_log_entity($values);
            break;
          default:
            break;
        }
      }
      break;
    case 'delete':
      foreach($logging as $log_key =>$log_value){
        switch ($log_key) {
          case 'watchdog':
            if($log_value === $log_key){
              db_set_active(variable_get('entity_log_database_selected','default'));
              watchdog('entity_log', 'Entity: @type, Bundle: @bundle, ID: @id is deleted by user @uid .',
              [
                '@type' => $type,
                '@bundle' => $entity->type,
                '@id' => $id,
                '@uid' => $entity->uid,
              ],
              $severity = WATCHDOG_INFO,
              $link = NULL);
            }
            db_set_active();
            break;
          case 'entity':
            //entity_log_create_entity_log_entity($values);
            break;
          default:
            break;
        }
      }
      break;
    case 'update':
      //compare data from updated entity with original one and prepare array for logging
      module_load_include('inc', 'entity_log', 'includes/entity_log.compare');
      $log_data = entity_log_compare($entity,$type,$log_type,$fields);
      //log prepared data per logging type

      foreach($logging as $log_key =>$log_value){
          switch ($log_key) {
            case 'watchdog':
              if($log_value === $log_key){
                if(isset($log_data['fields'])){
                  foreach($log_data['fields'] as $field_name => $fields_value){
                    db_set_active(variable_get('entity_log_database_selected','default'));
                    watchdog('entity_log', 'Entity type: @type, Bundle/type: @bundle,ID @id, field: @field, old value: @old_value, new value: @new_value,user: @uid, ip: @ip',
                    [
                      '@type' => $type,
                      '@bundle' => $entity->type,
                      '@field'=>$field_name,
                      '@old_value' => $fields_value['old_value'],
                      '@new_value' => $fields_value['new_value'],
                      '@id' => $id,
                      '@uid' => $entity->uid,
                      '@ip' => ip_address()
                    ],
                    $severity = WATCHDOG_INFO,
                    $link = NULL);
                    db_set_active();
                  }
                }
                if(isset($log_data['properties'])){
                  foreach($log_data['properties'] as $property_name => $property_value){
                    db_set_active(variable_get('entity_log_database_selected','default'));
                    watchdog('entity_log', 'Entity type: @type, Bundle/type: @bundle,ID @id, property: @field, old value: @old_value, new value: @new_value,user: @uid, ip: @ip',
                    [
                      '@type' => $type,
                      '@bundle' => $entity->type,
                      '@field'=>$property_name,
                      '@old_value' => $property_value['old_value'],
                      '@new_value' => $property_value['new_value'],
                      '@id' => $id,
                      '@uid' => $entity->uid,
                      '@ip' => ip_address()
                    ],
                    $severity = WATCHDOG_INFO,
                    $link = NULL);
                    db_set_active();
                    break;
                  }
                }
              }
              break;
            case 'entity':
              if($log_value === $log_key){
                if(isset($log_data['fields'])){
                  foreach($log_data['fields'] as $field_name => $fields_value){
                    $values['log_type'] = 'update';
                    $values['entity_type'] = $type;
                    $values['entity_bundle'] = $entity->type;
                    $values['field_name'] = $field_name;
                    $values['old_value'] = $fields_value['old_value'];
                    $values['new_value'] = $fields_value['new_value'];
                    $values['uid'] = $entity->uid;
                    $values['message'] = t('Entity type: @type, Bundle/type: @bundle,ID @id, field: @field, old value: @old_value, new value: @new_value,user: @uid, ip: @ip',
                    [
                      '@type' => $type,
                      '@bundle' => $values['entity_bundle'] ,
                      '@field'=>$field_name,
                      '@old_value' => $fields_value['old_value'],
                      '@new_value' => $fields_value['new_value'],
                      '@id' => $id,
                      '@uid' => $entity->uid,
                      '@ip' => ip_address()
                    ]);
                    entity_log_create_entity_log_entity($values);
                  }
                }
                if(isset($log_data['properties'])){
                  foreach($log_data['properties'] as $property_name => $property_value){
                    $values['log_type'] = 'update';
                    $values['entity_type'] = $type;
                    $values['entity_bundle'] = $entity->type;
                    $values['field_name'] = $property_name;
                    $values['message'] = '';
                    $values['old_value'] = $property_value['old_value'];
                    $values['new_value'] = $property_value['new_value'];
                    $values['uid'] = $entity->uid;
                    $values['message'] = t('Entity type: @type, Bundle/type: @bundle,ID @id, property: @field, old value: @old_value, new value: @new_value,user: @uid, ip: @ip',
                    [
                      '@type' => $type,
                      '@bundle' => $entity->type,
                      '@field'=>$property_name,
                      '@old_value' => $property_value['old_value'],
                      '@new_value' => $property_value['new_value'],
                      '@id' => $id,
                      '@uid' => $entity->uid,
                      '@ip' => ip_address()
                    ]);
                    entity_log_create_entity_log_entity($values);
                  }
                }
              }
              //@todo do logging on entity
              break;
            default:
              # code...
              break;
          }
      }
      break;
    default:
      break;
  }
}

/**
 * Entity log create
 * @param  [type] $values [description]
 * @return [type]         [description]
 * values required:
 * values = [
 * 'log_type',
 * 'entity_type',
 * 'field_name',
 * 'message',
 * 'old_value',
 * 'new_value'
 * ]
 */
function entity_log_create_entity_log_entity($values = []){
  global $user;
  db_set_active(variable_get('entity_log_database_selected','default'));
  $values_needed = [
    'uid',
    'log_type',
    'entity_type',
    'entity_bundle',
    'field_name',
    'message',
    'old_value',
    'new_value',
    'created',
    'hostname'
  ];
  $entity_log = entity_create('entity_log',array('type'=>'entity_log'));
  foreach($values_needed as $vals){
    switch ($vals) {
      case 'uid':
        if(empty($values[$vals])){
          $entity_log->$vals = $user->$vals;
        }else{
          $entity_log->$vals = $values['uid'];
        }
        break;
      case 'log_type':
        if(empty($values[$vals])){
          $values[$vals] = 'entity_log';
        }else{
          $entity_log->$vals = $values[$vals];
        }
        break;
      case 'entity_type':
      case 'entity_bundle':
      case 'field_name':
      case 'message':
      case 'old_value':
      case 'new_value':
        $entity_log->$vals = $values[$vals];
        break;
      case 'created':
        if(empty($values[$vals])){
          $entity_log->$vals = time();
        }
        break;
      case 'hostname':
        if(empty($values[$vals])){
          $entity_log->$vals = ip_address();
        }
        break;
      default:
        break;
    }
  }

  $entity_log->save();
  db_set_active();
}


function entity_log_entry_test(){
  $values = [
    'uid' => 1,
    'log_type',
    'entity_type' => 'test',
    'entity_bundle' => 'test2',
    'field_name' => 'test3',
    'message' => 'test4',
    'old_value' => 'test5',
    'new_value' => 'test6',
  ];
  entity_log_create_entity_log_entity($values);
}
