<?php
/**
 * @file Support for fields type
 */

function entity_log_field_text_with_summary($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  if(isset($entity_wrapper_old->$field->value)) {
    if($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()) {
      $old_value = $entity_wrapper_old->$field->value();
      $new_value = $entity_wrapper_new->$field->value();
      $body_old = array();
      if(isset($old_value['summary'])){
        $body_old['summary'] = 'summary: ' . $old_value['summary'];
      }
      if(isset($new_value['value'])){
        $body_old['value'] = 'value: ' . $old_value['value'];
      }
      if(isset($new_value['format'])){
        $body_old['format'] = 'format: ' . $old_value['format'];
      }
      $body_new = array();
      if(isset($new_value['summary'])){
        $body_new['summary'] = 'summary: ' . $new_value['summary'];
      }
      if(isset($new_value['value'])){
        $body_new['value'] = 'value: ' . $new_value['value'];
      }
      if(isset($new_value['format'])){
        $body_new['format'] = 'format: ' . $new_value['format'];
      }
      $log_data[$field]['old_value'] = implode($body_old,',');
      $log_data[$field]['new_value'] = implode($body_new,',');
    }
  }elseif($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()){
    //if fields are not same then log this
    $old_value = $entity_wrapper_old->$field->value();
    $new_value = $entity_wrapper_new->$field->value();

    $old_count = count($old_value);
    $new_count = count($new_value);

    if($old_count > 1){
      $term_old_array = array();
      for ($i = 0; $i < $old_count; $i++){
        $body_old = array();
        if(isset($old_value[$i]['summary'])){
          $body_old['summary'] = 'summary: ' . $old_value[$i]['summary'];
        }
        if(isset($new_value[$i]['value'])){
          $body_old['value'] = 'value: ' . $old_value[$i]['value'];
        }
        if(isset($new_value[$i]['format'])){
          $body_old['format'] = 'format: ' . $old_value[$i]['format'];
        }
        $tag_order_no = $i + 1;
        $body_old = implode($body_old,',');
        $term_old_array[$i] = 'BODY[' . $tag_order_no . ']: ' . $body_old;
      }
      $log_data[$field]['old_value'] = implode($term_old_array,'; ');
    }else{
      $body_old = array();
      if(isset($old_value[0]['summary'])){
        $body_old['summary'] = 'summary: ' . $old_value[0]['summary'];
      }
      if(isset($new_value[0]['value'])){
        $body_old['value'] = 'value: ' . $old_value[0]['value'];
      }
      if(isset($new_value[0]['format'])){
        $body_old['format'] = 'format: ' . $old_value[0]['format'];
      }
      $log_data[$field]['old_value'] = implode($body_old,',');
    }

    if($new_count > 1){
      $body_new_array = array();
      for ($i = 0; $i < $new_count; $i++){
        $body_new = array();
        if(isset($new_value[$i]['summary'])){
          $body_new['summary'] = 'summary: ' . $new_value[$i]['summary'];
        }
        if(isset($new_value[$i]['value'])){
          $body_new['value'] = 'value: ' . $new_value[$i]['value'];
        }
        if(isset($new_value[$i]['format'])){
          $body_new['format'] = 'format: ' . $new_value[$i]['format'];
        }
        $body_order_no = $i + 1;
        $body_new_string = implode($body_new,',');
        $body_new_array[$i] = 'BODY[' . $body_order_no . ']: ' . $body_new_string;
      }
      $log_data[$field]['new_value'] = implode($body_new_array,'; ');
    }else{
      $body_new = array();
      if(isset($new_value[0]['summary'])){
        $body_new['summary'] = 'summary: ' . $new_value[0]['summary'];
      }
      if(isset($new_value[0]['value'])){
        $body_new['value'] = 'value: ' . $new_value[0]['value'];
      }
      if(isset($new_value[0]['format'])){
        $body_new['format'] = 'format: ' . $new_value[0]['format'];
      }
      $log_data[$field]['new_value'] = implode($body_new,', ');
    }
  }elseif($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()){
    //if fields are not same then log this
    $log_data[$field]['old_value'] = implode($entity_wrapper_old->$field->value());
    $log_data[$field]['new_value'] = implode($entity_wrapper_new->$field->value());
  }
  return $log_data;
}

function entity_log_field_text($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  if(isset($entity_wrapper_old->$field->value)) {
    if($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()) {
      $old_value = $entity_wrapper_old->$field->value();
      $new_value = $entity_wrapper_new->$field->value();
      $log_data[$field]['old_value'] = $old_value;
      $log_data[$field]['new_value'] = $new_value;
    }
  }elseif($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()){
    //if fields are not same then log this
    $old_value = $entity_wrapper_old->$field->value();
    $new_value = $entity_wrapper_new->$field->value();

    $old_count = count($old_value);
    $new_count = count($new_value);

    if($old_count > 1){
      $text_old_array = array();
      for ($i = 0; $i < $old_count; $i++) {
        $text_old = $old_value[$i];
        $text_order_no = $i + 1;
        $text_old_array[$i] = 'TEXT[' . $text_order_no . ']: ' . $text_old;
      }
      $log_data[$field]['old_value'] = implode($text_old_array, '; ');
    }elseif (count($old_value) == 1 && count($new_value) > 1){
      $log_data[$field]['old_value'] = 'values: ' . implode($old_value,', ');
    }
    else{
      $log_data[$field]['old_value'] = $old_value;
    }
    if(count($new_value) > 1){
      $text_new_array = array();
      for ($i = 0; $i < $new_count; $i++) {
        $text_new = $new_value[$i];
        $text_order_no = $i + 1;
        $text_new_array[$i] = 'TEXT[' . $text_order_no . ']: ' . $text_new;
      }
      $log_data[$field]['new_value'] = implode($text_new_array, '; ');
    }elseif (count($new_value) == 1 && count($old_value) > 1){
      $log_data[$field]['new_value'] = 'values: ' . implode($new_value,', ');
    }
    else{
      $log_data[$field]['new_value'] = $new_value;
    }
  }
  return $log_data;
}

function entity_log_field_datetime($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  $old_value = $entity_wrapper_old->$field->value();
  $new_value = $entity_wrapper_new->$field->value();

  // If values are array, date field uses end time.
  if(is_array($old_value) && is_array($new_value)){
    // Check if any part of date field has changed
    foreach($old_value as $key => $datevalue){
      if($old_value[$key] !== $new_value[$key]){
        $values_changed = TRUE;
      }
    }
    // Already formatted
    $log_data_old = $old_value['value'] . ' | ' . $old_value['value2'];
    $log_data_new = $new_value['value'] . ' | ' . $new_value['value2'];

  }elseif($old_value != $new_value){
    $values_changed = TRUE;
    // Format date with timestamp
    $log_data_old = date('Y-m-d H:i:s', $old_value);
    $log_data_new = date('Y-m-d H:i:s', $new_value);
  }

  // If any changes were found, return them
  if(isset($values_changed) && $values_changed){
    $log_data[$field]['old_value'] = $log_data_old;
    $log_data[$field]['new_value'] = $log_data_new;
    return $log_data;
  }
}

function entity_log_field_file($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  if($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()){
    //if fields are not same then log this
    $old_value = $entity_wrapper_old->$field->value();
    $new_value = $entity_wrapper_new->$field->value();

    $old_count = count($old_value);
    $new_count = count($new_value);

    if (count($old_value) == count($old_value, COUNT_RECURSIVE)){
      $file_old = [
        'fid' => 'file id: ' . $old_value['fid'],
        'filename' => 'filename: ' . $old_value['filename'],
        'uri' => 'uri: ' .  $old_value['uri'],
        'filemime' => 'filemime: ' .  $old_value['filemime'],
        'filesize' => 'filesize: ' .  $old_value['filesize'],
      ];
      $file_new = array();
      if(isset($new_value['fid'])){
        $file_new['fid'] = 'file id: ' . $new_value['fid'];
      }
      if(isset($new_value['filename'])){
        $file_new['filename'] = 'filename: ' . $new_value['filename'];
      }
      if(isset($new_value['uri'])){
        $file_new['uri'] = 'uri: ' . $new_value['uri'];
      }
      if(isset($new_value['filemime'])){
        $file_new['filemime'] = 'filemime: ' . $new_value['filemime'];
      }
      if(isset($new_value['filesize'])){
        $file_new['filesize'] = 'filesize: ' . $new_value['filesize'];
      }
      $log_data[$field]['old_value'] = implode($file_old,',');
      $log_data[$field]['new_value'] = implode($file_new,',');
    }else{
      if($old_count > 1){
        $file_old_array = array();
        for ($i = 0; $i < $old_count; $i++){
          $file_old = [
            'fid' => 'file id: ' . $old_value[$i]['fid'],
            'filename' => 'filename: ' . $old_value[$i]['filename'],
            'uri' => 'uri: ' .  $old_value[$i]['uri'],
            'filemime' => 'filemime: ' .  $old_value[$i]['filemime'],
            'filesize' => 'filesize: ' .  $old_value[$i]['filesize'],
          ];
          $file_order_no = $i + 1;
          $file_old = implode($file_old,',');
          $file_old_array[$i] = 'FILE[' . $file_order_no . ']: ' . $file_old;
        }
        $log_data[$field]['old_value'] = implode($file_old_array,'; ');
      }else{
        $file_old = [
          'fid' => 'file id: ' . $old_value[0]['fid'],
          'filename' => 'filename: ' . $old_value[0]['filename'],
          'uri' => 'uri: ' .  $old_value[0]['uri'],
          'filemime' => 'filemime: ' .  $old_value[0]['filemime'],
          'filesize' => 'filesize: ' .  $old_value[0]['filesize'],
        ];
        $log_data[$field]['old_value'] = implode($file_old,',');
      }

      if($new_count > 1){
        $file_new_array = array();
        for ($i = 0; $i < $new_count; $i++){
          $file_new = array();
          if(isset($new_value[$i]['fid'])){
            $file_new['fid'] = 'file id: ' . $new_value[$i]['fid'];
          }
          if(isset($new_value[$i]['filename'])){
            $file_new['filename'] = 'filename: ' . $new_value[$i]['filename'];
          }
          if(isset($new_value[$i]['uri'])){
            $file_new['uri'] = 'uri: ' . $new_value[$i]['uri'];
          }
          if(isset($new_value[$i]['filemime'])){
            $file_new['filemime'] = 'filemime: ' . $new_value[$i]['filemime'];
          }
          if(isset($new_value[$i]['filesize'])){
            $file_new['filesize'] = 'filesize: ' . $new_value[$i]['filesize'];
          }
          $file_order_no = $i + 1;
          $file_new_string = implode($file_new,',');
          $file_new_array[$i] = 'FILE[' . $file_order_no . ']: ' . $file_new_string;
        }
        $log_data[$field]['new_value'] = implode($file_new_array,'; ');
      }else{
        $file_new = array();
        if(isset($new_value[0]['fid'])){
          $file_new['fid'] = 'file id: ' . $new_value[0]['fid'];
        }
        if(isset($new_value[0]['filename'])){
          $file_new['filename'] = 'filename: ' . $new_value[0]['filename'];
        }
        if(isset($new_value[0]['uri'])){
          $file_new['uri'] = 'uri: ' . $new_value[0]['uri'];
        }
        if(isset($new_value[0]['filemime'])){
          $file_new['filemime'] = 'filemime: ' . $new_value[0]['filemime'];
        }
        if(isset($new_value[0]['filesize'])){
          $file_new['filesize'] = 'filesize: ' . $new_value[0]['filesize'];
        }
        $log_data[$field]['new_value'] = implode($file_new,', ');
      }
    }
  }
  return $log_data;
}

function entity_log_field_image($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  if($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()){
    //if fields are not same then log this
    $old_value = $entity_wrapper_old->$field->value();
    $new_value = $entity_wrapper_new->$field->value();

    $old_count = count($old_value);
    $new_count = count($new_value);

    if (count($old_value) == count($old_value, COUNT_RECURSIVE)){
      if(empty($old_value)){
        $image_old = 'empty';
        $log_data[$field]['old_value'] = $image_old;
      }else{
        if(isset($old_value['fid'])){
          $image_old['fid'] = 'file id: ' . $old_value['fid'];
        }
        if(isset($old_value['filename'])){
          $image_old['filename'] = 'filename: ' . $old_value['filename'];
        }
        if(isset($old_value['uri'])){
          $image_old['uri'] = 'uri: ' . $old_value['uri'];
        }
        if(isset($old_value['filemime'])){
          $image_old['filemime'] = 'filemime: ' . $old_value['filemime'];
        }
        if(isset($old_value['filesize'])){
          $image_old['filesize'] = 'filesize: ' . $old_value['filesize'];
        }
        if(isset($old_value['alt'])){
          $image_old['alt'] = 'alt: ' . $old_value['alt'];
        }
        if(isset($old_value['title'])){
          $image_old['title'] = 'title: ' . $old_value['title'];
        }
        if(isset($old_value['width'])){
          $image_old['width'] = 'width: ' . $old_value['width'];
        }
        if(isset($old_value['height'])){
          $image_old['height'] = 'height: ' . $old_value['height'];
        }
        $log_data[$field]['old_value'] = implode($image_old,',');
      }
      $image_new = array();
      if(!isset($new_value[0])){
        if(isset($new_value['fid'])){
          $image_new['fid'] = 'file id: ' . $new_value['fid'];
        }
        if(isset($new_value['filename'])){
          $image_new['filename'] = 'filename: ' . $new_value['filename'];
        }
        if(isset($new_value['uri'])){
          $image_new['uri'] = 'uri: ' . $new_value['uri'];
        }
        if(isset($new_value['filemime'])){
          $image_new['filemime'] = 'filemime: ' . $new_value['filemime'];
        }
        if(isset($new_value['filesize'])){
          $image_new['filesize'] = 'filesize: ' . $new_value['filesize'];
        }
        if(isset($new_value['alt'])){
          $image_new['alt'] = 'alt: ' . $new_value['alt'];
        }
        if(isset($new_value['title'])){
          $image_new['title'] = 'title: ' . $new_value['title'];
        }
        if(isset($new_value['width'])){
          $image_new['width'] = 'width: ' . $new_value['width'];
        }
        if(isset($new_value['height'])){
          $image_new['height'] = 'height: ' . $new_value['height'];
        }
        if(empty($image_new)){
          $log_data[$field]['new_value'] = 'empty';
        }else{
          $log_data[$field]['new_value'] = implode($image_new,',');
        }
      }else{
          $image_new_array = array();
          for ($i = 0; $i < $new_count; $i++) {
            $image_new = array();
            if (isset($new_value[$i]['fid'])) {
              $image_new['fid'] = 'file id: ' . $new_value[$i]['fid'];
            }
            if (isset($new_value[$i]['filename'])) {
              $image_new['filename'] = 'filename: ' . $new_value[$i]['filename'];
            }
            if (isset($new_value[$i]['uri'])) {
              $image_new['uri'] = 'uri: ' . $new_value[$i]['uri'];
            }
            if (isset($new_value[$i]['filemime'])) {
              $image_new['filemime'] = 'filemime: ' . $new_value[$i]['filemime'];
            }
            if (isset($new_value[$i]['filesize'])) {
              $image_new['filesize'] = 'filesize: ' . $new_value[$i]['filesize'];
            }
            if (isset($new_value[$i]['alt'])) {
              $image_new['alt'] = 'alt: ' . $new_value[$i]['alt'];
            }
            if (isset($new_value[$i]['title'])) {
              $image_new['title'] = 'title: ' . $new_value[$i]['title'];
            }
            if (isset($new_value[$i]['width'])) {
              $image_new['width'] = 'width: ' . $new_value[$i]['width'];
            }
            if (isset($new_value[$i]['height'])) {
              $image_new['height'] = 'height: ' . $new_value[$i]['height'];
            }
            $image_order_no = $i + 1;
            $image_new_string = implode($image_new, ',');
            $image_new_array[$i] = 'IMAGE[' . $image_order_no . ']: ' . $image_new_string;
          }
          $log_data[$field]['new_value'] = implode($image_new_array, '; ');
      }
    }else{
      if($old_count > 1){
        $image_old_array = array();
        for ($i = 0; $i < $old_count; $i++){
          if(isset($old_value[$i]['fid'])){
            $image_old['fid'] = 'file id: ' . $old_value[$i]['fid'];
          }
          if(isset($old_value[$i]['filename'])){
            $image_old['filename'] = 'filename: ' . $old_value[$i]['filename'];
          }
          if(isset($old_value[$i]['uri'])){
            $image_old['uri'] = 'uri: ' . $old_value[$i]['uri'];
          }
          if(isset($old_value[$i]['filemime'])){
            $image_old['filemime'] = 'filemime: ' . $old_value[$i]['filemime'];
          }
          if(isset($old_value[$i]['filesize'])){
            $image_old['filesize'] = 'filesize: ' . $old_value[$i]['filesize'];
          }
          if(isset($old_value[$i]['alt'])){
            $image_old['alt'] = 'alt: ' . $old_value[$i]['alt'];
          }
          if(isset($old_value[$i]['title'])){
            $image_old['title'] = 'title: ' . $old_value[$i]['title'];
          }
          if(isset($old_value[$i]['width'])){
            $image_old['width'] = 'width: ' . $old_value[$i]['width'];
          }
          if(isset($old_value[$i]['height'])){
            $image_old['height'] = 'height: ' . $old_value[$i]['height'];
          }
          $image_order_no = $i + 1;
          $image_old1 = implode($image_old,',');
          $image_old_array[$i] = 'IMAGE[' . $image_order_no . ']: ' . $image_old1;
        }
        $log_data[$field]['old_value'] = implode($image_old_array,'; ');
      }else{
        if(empty($old_value)){
          $image_old = 'empty';
          $log_data[$field]['old_value'] = $image_old;
        }else{
          if(!isset($old_value[0])){
            if(isset($old_value['fid'])){
              $image_old['fid'] = 'file id: ' . $old_value['fid'];
            }
            if(isset($old_value['filename'])){
              $image_old['filename'] = 'filename: ' . $old_value['filename'];
            }
            if(isset($old_value['uri'])){
              $image_old['uri'] = 'uri: ' . $old_value['uri'];
            }
            if(isset($old_value['filemime'])){
              $image_old['filemime'] = 'filemime: ' . $old_value['filemime'];
            }
            if(isset($old_value['filesize'])){
              $image_old['filesize'] = 'filesize: ' . $old_value['filesize'];
            }
            if(isset($old_value['alt'])){
              $image_old['alt'] = 'alt: ' . $old_value['alt'];
            }
            if(isset($old_value['title'])){
              $image_old['title'] = 'title: ' . $old_value['title'];
            }
            if(isset($old_value['width'])){
              $image_old['width'] = 'width: ' . $old_value['width'];
            }
            if(isset($old_value['height'])){
              $image_old['height'] = 'height: ' . $old_value['height'];
            }
            $log_data[$field]['old_value'] = implode($image_old,',');
          }else{
            $image_old_array = array();
            for ($i = 0; $i < $old_count; $i++){
              if(isset($old_value['fid'])){
                $image_old[$i]['fid'] = 'file id: ' . $old_value[$i]['fid'];
              }
              if(isset($old_value[$i]['filename'])){
                $image_old['filename'] = 'filename: ' . $old_value[$i]['filename'];
              }
              if(isset($old_value[$i]['uri'])){
                $image_old['uri'] = 'uri: ' . $old_value[$i]['uri'];
              }
              if(isset($old_value[$i]['filemime'])){
                $image_old['filemime'] = 'filemime: ' . $old_value[$i]['filemime'];
              }
              if(isset($old_value[$i]['filesize'])){
                $image_old['filesize'] = 'filesize: ' . $old_value[$i]['filesize'];
              }
              if(isset($old_value[$i]['alt'])){
                $image_old['alt'] = 'alt: ' . $old_value[$i]['alt'];
              }
              if(isset($old_value[$i]['title'])){
                $image_old['title'] = 'title: ' . $old_value[$i]['title'];
              }
              if(isset($old_value[$i]['width'])){
                $image_old['width'] = 'width: ' . $old_value[$i]['width'];
              }
              if(isset($old_value[$i]['height'])){
                $image_old['height'] = 'height: ' . $old_value[$i]['height'];
              }
              $image_order_no = $i + 1;
              $image_old1 = implode($image_old,',');
              $image_old_array[$i] = 'IMAGE[' . $image_order_no . ']: ' . $image_old1;
            }
            $log_data[$field]['old_value'] = implode($image_old_array,', ');
          }
        }
      }

      if($new_count > 1){
        $image_new_array = array();
        for ($i = 0; $i < $new_count; $i++){
          $image_new = array();
          if(isset($new_value[$i]['fid'])){
            $image_new['fid'] = 'file id: ' . $new_value[$i]['fid'];
          }
          if(isset($new_value[$i]['filename'])){
            $image_new['filename'] = 'filename: ' . $new_value[$i]['filename'];
          }
          if(isset($new_value[$i]['uri'])){
            $image_new['uri'] = 'uri: ' . $new_value[$i]['uri'];
          }
          if(isset($new_value[$i]['filemime'])){
            $image_new['filemime'] = 'filemime: ' . $new_value[$i]['filemime'];
          }
          if(isset($new_value[$i]['filesize'])){
            $image_new['filesize'] = 'filesize: ' . $new_value[$i]['filesize'];
          }
          if(isset($new_value[$i]['alt'])){
            $image_new['alt'] = 'alt: ' . $new_value[$i]['alt'];
          }
          if(isset($new_value[$i]['title'])){
            $image_new['title'] = 'title: ' . $new_value[$i]['title'];
          }
          if(isset($new_value[$i]['width'])){
            $image_new['width'] = 'width: ' . $new_value[$i]['width'];
          }
          if(isset($new_value[$i]['height'])){
            $image_new['height'] = 'height: ' . $new_value[$i]['height'];
          }
          $image_order_no = $i + 1;
          $image_new_string = implode($image_new,',');
          $image_new_array[$i] = 'IMAGE[' . $image_order_no . ']: ' . $image_new_string;
        }
        $log_data[$field]['new_value'] = implode($image_new_array,'; ');
      }else{
        $image_new = array();
        if(isset($new_value[0]['fid'])){
          $image_new['fid'] = 'file id: ' . $new_value[0]['fid'];
        }
        if(isset($new_value[0]['filename'])){
          $image_new['filename'] = 'filename: ' . $new_value[0]['filename'];
        }
        if(isset($new_value[0]['uri'])){
          $image_new['uri'] = 'uri: ' . $new_value[0]['uri'];
        }
        if(isset($new_value[0]['filemime'])){
          $image_new['filemime'] = 'filemime: ' . $new_value[0]['filemime'];
        }
        if(isset($new_value[0]['filesize'])){
          $image_new['filesize'] = 'filesize: ' . $new_value[0]['filesize'];
        }
        if(isset($new_value[0]['alt'])){
          $image_new['alt'] = 'alt: ' . $new_value[0]['alt'];
        }
        if(isset($new_value[0]['title'])){
          $image_new['title'] = 'title: ' . $new_value[0]['title'];
        }
        if(isset($new_value[0]['width'])){
          $image_new['width'] = 'width: ' . $new_value[0]['width'];
        }
        if(isset($new_value[0]['height'])){
          $image_new['height'] = 'height: ' . $new_value[0]['height'];
        }
        $log_data[$field]['new_value'] = implode($image_new,', ');
      }
    }
  }
  return $log_data;
}


function entity_log_field_taxonomy_term_reference($entity_wrapper_old, $entity_wrapper_new, $field) {
  $log_data = array();
  if(isset($entity_wrapper_old->$field->value)) {
    $test = 1;
  }
  if ($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()) {
    //if fields are not same then log this
    $old_value = $entity_wrapper_old->$field->value();
    $new_value = $entity_wrapper_new->$field->value();

    $old_count = count($old_value);
    $new_count = count($new_value);

    if (is_object($old_value) || is_object($new_value)) {
      if ($old_count > 1) {
        $term_old_array = array();
        for ($i = 0; $i < $old_count; $i++) {
          if (isset($old_value[$i]->tid)) {
            $term_old['tid'] = 'tid: ' . $old_value[$i]->tid;
          }
          if (isset($old_value[$i]->name)) {
            $term_old['name'] = 'name: ' . $old_value[$i]->name;
          }
          if (isset($old_value[$i]->vocabulary_machine_name)) {
            $term_old['vocabulary_machine_name'] = 'vocabulary_machine_name: ' . $old_value[$i]->vocabulary_machine_name;
          }
          $term_old = implode($term_old, ',');
          $term_old_array[$i] = $term_old;
        }
        $log_data[$field]['old_value'] = implode($term_old_array, ',');
      }
      else {
        if(!empty($old_value)){
          if (isset($old_value->tid)) {
            $term_old['tid'] = 'tid: ' . $old_value->tid;
          }
          if (isset($old_value->name)) {
            $term_old['name'] = 'name: ' . $old_value->name;
          }
          if (isset($old_value->vocabulary_machine_name)) {
            $term_old['vocabulary_machine_name'] = 'vocabulary_machine_name: ' . $old_value->vocabulary_machine_name;
          }
          $log_data[$field]['old_value'] = implode($term_old, ', ');
        }else{
          $term_old = 'empty';
          $log_data[$field]['old_value'] = $term_old;
        }

        $term_new = array();
        if(!empty($new_value)){
          if (isset($new_value->tid)) {
            $term_new['tid'] = 'tid: ' . $new_value->tid;
          }
          if (isset($new_value->name)) {
            $term_new['name'] = 'name: ' . $new_value->name;
          }
          if (isset($new_value->vocabulary_machine_name)) {
            $term_new['vocabulary_machine_name'] = 'vocabulary_machine_name: ' . $new_value->vocabulary_machine_name;
          }
          $log_data[$field]['new_value'] = implode($term_new, ', ');
        }else{
          $term_new = 'empty';
          $log_data[$field]['new_value'] = $term_new;
        }
      }
    }


    else {
      if ($old_count > 1) {
        $term_old_array = array();
        $term_old = array();
        for ($i = 0; $i < $old_count; $i++) {
          if(isset($old_value[$i]->tid)){
            $term_old['tid'] = 'file id: ' .  $old_value[$i]->tid;
          }
          if(isset($old_value[$i]->name)){
            $term_old['name'] = 'filename: ' . $old_value[$i]->name;
          }
          if(isset($old_value[$i]->vocabulary_machine_name)){
            $term_old['vocabulary_machine_name'] = 'vocabulary machine name: ' . $old_value[$i]->vocabulary_machine_name;
          }
          $tag_order_no = $i + 1;
          $term_old = implode($term_old, ',');
          $term_old_array[$i] = 'TAG[' . $tag_order_no . ']: ' . $term_old;
        }
        $log_data[$field]['old_value'] = implode($term_old_array, '; ');
      }
      else {
        $term_old = array();
        if(!empty($old_value)){
          if(isset($old_value[0]->tid)){
            $term_old['tid'] = 'tid: ' . $old_value[0]->tid;
          }
          if(isset($old_value[0]->name)){
            $term_old['name'] = 'name: ' . $old_value[0]->name;
          }
          if(isset($old_value[0]->vocabulary_machine_name)){
            $term_old['vocabulary_machine_name'] = $old_value[0]->vocabulary_machine_name;
          }
          $log_data[$field]['old_value'] = implode($term_old, ',');
        }else{
          $term_old = 'empty';
          $log_data[$field]['old_value'] = $term_old;
        }
      }

      if ($new_count > 1) {
        $term_new_array = array();
        for ($i = 0; $i < $new_count; $i++) {
          $term_new = array();
          if (isset($new_value[$i]->tid)) {
            $term_new['tid'] = 'tid: ' . $new_value[$i]->tid;
          }
          if (isset($new_value[$i]->tid)) {
            $term_new['tid'] = 'tid: ' . $new_value[$i]->tid;
          }
          if (isset($new_value[$i]->name)) {
            $term_new['name'] = 'name: ' . $new_value[$i]->name;
          }
          if (isset($new_value[$i]->vocabulary_machine_name)) {
            $term_new['vocabulary_machine_name'] = 'vocabulary_machine_name: ' . $new_value[$i]->vocabulary_machine_name;
          }
          $tag_order_no = $i + 1;
          $term_new_string = implode($term_new, ',');
          $term_new_array[$i] = 'TAG[' . $tag_order_no . ']: ' . $term_new_string;
        }
        $log_data[$field]['new_value'] = implode($term_new_array, '; ');
      }
      else {
        $term_new = array();
        if(!isset($new_value[0])){
          if (isset($new_value->tid)) {
            $term_new['tid'] = 'tid: ' . $new_value->tid;
          }
          if (isset($new_value->name)) {
            $term_new['name'] = 'name: ' . $new_value->name;
          }
          if (isset($new_value->vocabulary_machine_name)) {
            $term_new['vocabulary_machine_name'] = 'vocabulary_machine_name: ' . $new_value->vocabulary_machine_name;
          }
          $log_data[$field]['new_value'] = implode($term_new, ', ');
        }else{
          for ($i = 0; $i < $new_count; $i++) {
            $term_new = array();
            if (isset($new_value[$i]->tid)) {
              $term_new['tid'] = 'tid: ' . $new_value[$i]->tid;
            }
            if (isset($new_value[$i]->tid)) {
              $term_new['tid'] = 'tid: ' . $new_value[$i]->tid;
            }
            if (isset($new_value[$i]->name)) {
              $term_new['name'] = 'name: ' . $new_value[$i]->name;
            }
            if (isset($new_value[$i]->vocabulary_machine_name)) {
              $term_new['vocabulary_machine_name'] = 'vocabulary_machine_name: ' . $new_value[$i]->vocabulary_machine_name;
            }
            $tag_order_no = $i + 1;
            $term_new_string = implode($term_new, ',');
            $term_new_array[$i] = 'TAG[' . $tag_order_no . ']: ' . $term_new_string;
          }
          $log_data[$field]['new_value'] = implode($term_new_array, ';');
        }
      }
//      $term_new = implode($term_new, ',');
//      $term_new_array[$i] = $term_new;
//      $log_data[$field]['new_value'] = implode($term_new_array, ',');
    }
  }

//  else {
//    if (isset($new_value[0]->tid)) {
//      $term_new['tid'] = 'tid: ' . $new_value[0]->tid;
//    }
//    if (isset($new_value[0]->name)) {
//      $term_new['name'] = 'name: ' . $new_value[0]->name;
//    }
//    if (isset($new_value[0]->vocabulary_machine_name)) {
//      $term_new['vocabulary_machine_name'] = 'vocabulary_machine_name: ' . $new_value[0]->vocabulary_machine_name;
//    }
//    $log_data[$field]['new_value'] = implode($term_new, ',');
//  }
  return $log_data;
}

function entity_log_field_list($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  if($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()){
    //if fields are not same then log this
    $old_value = $entity_wrapper_old->$field->value();
    $new_value = $entity_wrapper_new->$field->value();
    if(count($old_value) > 1){
      $log_data[$field]['old_value'] = 'values: ' . implode($old_value,',');
    }else{
      $log_data[$field]['old_value'] = 'values: ' . implode($old_value,',');
    }
    if(count($new_value) > 1){
      $log_data[$field]['new_value'] = 'values: ' . implode($new_value,',');
    }else{
      $log_data[$field]['new_value'] = 'values: ' . implode($new_value,',');
    }
  }
  return $log_data;
}

function entity_log_field_number($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  if(isset($entity_wrapper_old->$field->value)) {
    if($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()) {
      $old_value = $entity_wrapper_old->$field->value();
      $new_value = $entity_wrapper_new->$field->value();
      $log_data[$field]['old_value'] = $old_value;
      $log_data[$field]['new_value'] = $new_value;
    }
  }elseif($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()){
    //if fields are not same then log this
    $old_value = $entity_wrapper_old->$field->value();
    $new_value = $entity_wrapper_new->$field->value();
    if(count($old_value) > 1){
      $log_data[$field]['old_value'] = 'values: ' . implode($old_value,',');
    }else{
      $log_data[$field]['old_value'] = $old_value;
    }
    if(count($new_value) > 1){
      $log_data[$field]['$new_value'] = 'values: ' . implode($new_value,',');
    }else{
      $log_data[$field]['new_value'] = $new_value;
    }
  }
  return $log_data;
}

function entity_log_field_commerce_price($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  if($entity_wrapper_old->$field->value() != $entity_wrapper_new->$field->value()){
    //if fields are not same then log this
    $old_value = $entity_wrapper_old->$field->value();
    $new_value = $entity_wrapper_new->$field->value();
    $price_old = [
      'amount' => 'amount: ' . $old_value['amount'],
      'currency_code' => ' currency_code: ' . $old_value['currency_code'],
    ];
    if(isset($new_value['amount'])){
      $price_new['amount'] = 'amount: ' . $new_value['amount'];
    }
    if(isset($new_value['currency_code'])) {
      $price_new['currency_code'] = ' currency_code: ' . $new_value['currency_code'];
    }
    $log_data[$field]['old_value'] = implode($price_old,',');
    $log_data[$field]['new_value'] = implode($price_new,',');
  }
  return $log_data;
}

function entity_log_field_commerce_line_item_reference($entity_wrapper_old, $entity_wrapper_new, $field){
  $log_data = array();
  $old_values = $entity_wrapper_old->$field->value();
  $new_values = $entity_wrapper_new->$field->value();
  $log_data_old = [];
  $log_data_new = [];

  foreach ($new_values as $key => $new_line_item) {
    $log_data_new[] = $new_line_item->line_item_id;
    if($new_line_item->line_item_id !== $old_values[$key]->line_item_id){
      $values_changed = TRUE;
    }
  }

  if(isset($values_changed) && $values_changed){
    foreach ($old_values as $key => $old_line_item) {
      $log_data_old[] = $old_line_item->line_item_id;
    }
    $log_data[$field]['old_value'] = 'Line Item Ids: ' . implode($log_data_old, ',');
    $log_data[$field]['new_value'] = 'Line Item Ids: ' . implode($log_data_new, ',');
    return $log_data;
  }

}
